]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- block as broken
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
9c404149 10
ba1fdedc 11# kernel compiler
345d14e5 12%kgcc %{__cc}
d2e1bc22 13%kgcc_package gcc
ba1fdedc 14
46763914 15# compiler version
69bcfbf3 16%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 17%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 18
69bcfbf3 19%__rm /bin/rm --interactive=never
36eccf0d 20
33040789 21# Build system path macros.
69bcfbf3
ER
22%__autoconf autoconf %{?debug:-Wall}
23%__automake automake -a -c -f --foreign
24%__autopoint autopoint --force
25
26# add parallel build flags: -jN
a5656a95 27#
11ecb0a1
ER
28# if you want to disable parallel build do:
29# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 30#
11ecb0a1
ER
31%__make /usr/bin/make %{?_smp_mflags}
32%__scons /usr/bin/scons %{?_smp_mflags}
33%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 34%__cmake /usr/bin/cmake
a5656a95
JR
35
36%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
37 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 38
83094b62 39%__gettextize { \
8a995cff 40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 41 gettextize --copy --force --no-changelog; \
97589b6e 42 else \
3241033b 43 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
44 fi; \
45 if [ ! -f po/Makevars ]; then \
3241033b 46 cp -f po/Makevars{.template,}; \
8a995cff 47 fi; \
8a995cff 48}
f93109a0 49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
fb59e475 52%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
c26f1b59 55%__libtoolize libtoolize --copy --force --install
33040789 56
1052b4b8
ER
57# topdir is where builder script lives, fallback to old style if builder script was not found and
58# SPECS/SOURCES dirs exist (XXX: should be reverse?)
646a0d1b 59# XXX: fixed location for now: ~/rpm/packages
2df1b3e9 60%_topdir %{expand:%%global _topdir %(echo $HOME/rpm/packages)}%_topdir
1052b4b8
ER
61
62# if %{_topdir}/builder exists, it's new style structure
2df1b3e9
ER
63# XXX: fixed location for now: topdir/{SPECS,SOURCES}
64%_specdir %{_topdir}/SPECS
65%_sourcedir %{_topdir}/SOURCES
1052b4b8
ER
66
67# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
68# if they don't exist assume we are having custom topdir (which is not named as
69# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
70%_builddir %{expand:%%global _builddir %([ -d %{_topdir}/../BUILD ] && (cd %{_topdir}/../BUILD; pwd) || echo %{_topdir}/BUILD)}%_builddir
71%_rpmdir %{expand:%%global _rpmdir %([ -d %{_topdir}/../RPMS ] && (cd %{_topdir}/../RPMS; pwd) || echo %{_topdir}/RPMS)}%_rpmdir
72%_srcrpmdir %{expand:%%global _srcrpmdir %([ -d %{_topdir}/../SRPMS ] && (cd %{_topdir}/../SRPMS; pwd) || echo %{_topdir}/SRPMS)}%_srcrpmdir
384e1b2b 73
81e450f7
ER
74# The number of cvs changelog entries kept when building package.
75%_buildchangelogtruncate 20
76
6a5eda77 77%dependencytracking %{nil}
3241033b 78
e5da9169
ER
79# Relations between package names that cause dependency loops
80# with legacy packages that cannot be fixed. Relations are
81# specified as
82# p>q
83# where package p has a Requires: on something that package q Provides:
84#
85# XXX Note: that there cannot be any whitespace within the string "p>q",
86# and that both p and q are package names (i.e. no version/release).
87%_dependency_whiteout %{nil}
88
810fa5c4 89#-----------------------------------------------------------------
90#
91# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
92# BuildRequires: awk
93# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 94#
95# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 96# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
97# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 98# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 99# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 100#
101# Regular expressions are supported, but to avoid some character be treated
102# as regular expression it must be escaped twice.
103
104%filter_out \
7b6f1112 105 for (i = 1; i in I; i++) { A=0; \
810fa5c4 106 for (f in F) { \
107 if (I[i] ~ "^" F[f] "$") A=1; \
108 }; \
109 if (!A) printf(I[i] FS); \
110 }
111
112%rpmcflags %(awk 'BEGIN {
113 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 114 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 115 %{filter_out}
116}')
117
118%rpmcxxflags %(awk 'BEGIN {
09a90176 119 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
120 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 121 %{filter_out}
122}')
123
98e7f050
AM
124%rpmcppflags %(awk 'BEGIN {
125 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
126 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
127 %{filter_out}
128}')
129
810fa5c4 130%rpmldflags %(awk 'BEGIN {
c05a0741 131 split("%{?optldflags}",I);
810fa5c4 132 split("%{?filterout_ld}",F)
133 %{filter_out}
134}')
135
25f52d1a 136# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
137# but, don't use it, better use gcc as linker
138%ld_rpmldflags %(awk 'BEGIN {
139 split("%{rpmldflags}",F);
140 for (f in F) {
141 s = F[f];
142 if (s ~ /^-Wl,/) {
143 s = substr(s,5);
144 gsub(/,/," ",s);
145 };
146 printf(s FS);
147 };
148}')
149
8ef644e5 150#-----------------------------------------------------------------
151#
152# Generate a command which cleans environment, leaving only the
153# most important variables.
154# If any spec requires any additional environment it should
155# redefine %_preserve_env in following manner:
156#
157# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 158# %define _preserve_env ADDITIONAL_VAR
8ef644e5 159
57ba0f59 160%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 161
bb597f2b
AM
162# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
163%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 164 split("%{?_preserve_env}", P);
a363d727
ER
165 for (i in P) {
166 p = P[i];
82d10503
ER
167 if (!ENVIRON[p] || d[p]) {
168 continue;
8ef644e5 169 }
82d10503
ER
170 d[p] = 1;
171 split(ENVIRON[p], V, "");
172 val = p "=";
173 for (j = 1; j in V; j++) {
174 v = V[j];
175 if (v == q)
176 v = qq;
177 else if (v == "\\"")
178 v = q2q;
179 else if (v == "\\\\")
180 v = "\\\\\\\\";
181 else
182 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
183 val = val "" v;
184 }
185 printf(val " ");
8ef644e5 186 }
187}')
188
9c404149 189#-----------------------------------------------------------------
9f4ce098 190%configure2_13 { \
9c404149
AM
191 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
192 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
193 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 194 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 195 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 196 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 197 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
198 %{?__cc:CC="%{__cc}" ; export CC ; } \
199 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 200 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 201 --host=%{_target_platform} \
9c404149
AM
202 --prefix=%{_prefix} \
203 --exec-prefix=%{_exec_prefix} \
204 --bindir=%{_bindir} \
205 --sbindir=%{_sbindir} \
206 --sysconfdir=%{_sysconfdir} \
207 --datadir=%{_datadir} \
208 --includedir=%{_includedir} \
209 --libdir=%{_libdir} \
210 --libexecdir=%{_libexecdir} \
211 --localstatedir=%{_localstatedir} \
212 --sharedstatedir=%{_sharedstatedir} \
213 --mandir=%{_mandir} \
214 --infodir=%{_infodir} \
b6c5da52 215 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 216 %{dependencytracking} \
9c404149
AM
217}
218
39b9534b
ER
219%cmake { \
220CC="%{__cc}" \
221CXX="%{__cxx}" \
222CFLAGS="%{rpmcflags}" \
223CXXFLAGS="%{rpmcxxflags}" \
12513dc1 224LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
225%{__cmake} \
226}
227
89f4ca1f
ER
228%scons { \
229%{__scons} \
5c76736d
ER
230 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
231 CFLAGS="${CFLAGS:-%rpmcflags}" \
232 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
233 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 234 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
235 %{?__cc:CC="%{__cc}"} \
236 %{?__cxx:CXX="%{__cxx}"} \
237 libsuffix=%{_lib} \
238 prefix=%{_prefix} \
39b9534b
ER
239}
240
6339d32d 241# waf. see waf.spec
6339d32d 242%waf { \
6339d32d
ER
243CC="%{__cc}" \
244CXX="%{__cxx}" \
9e244007 245CPP="%{__cpp}" \
6339d32d
ER
246CFLAGS="%{rpmcflags}" \
247CXXFLAGS="%{rpmcxxflags}" \
248%{__waf} \
6339d32d
ER
249}
250
4a6b0d54 251#----------------------------------------------------------------
9bacbb5b 252#%configure_cache 0
fe6c4bdd 253%configure_cache_file %{buildroot}.configure.cache
73f832b3 254
e84cd836 255%configure {./configure \
4a6b0d54
AF
256 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
257 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 258 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 259 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 260 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 261 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
262 %{?__cc:CC="%{__cc}"} \
263 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 264 --host=%{_target_platform} \
4a6b0d54
AF
265 --build=%{_target_platform} \
266 --prefix=%{_prefix} \
267 --exec-prefix=%{_exec_prefix} \
268 --bindir=%{_bindir} \
269 --sbindir=%{_sbindir} \
270 --sysconfdir=%{_sysconfdir} \
271 --datadir=%{_datadir} \
272 --includedir=%{_includedir} \
273 --libdir=%{_libdir} \
274 --libexecdir=%{_libexecdir} \
275 --localstatedir=%{_localstatedir} \
276 --sharedstatedir=%{_sharedstatedir} \
277 --mandir=%{_mandir} \
278 --infodir=%{_infodir} \
b6c5da52 279 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 280 %{dependencytracking} \
9bacbb5b 281 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
282}
283
611a25d5 284# Simple macros to simplify adding bconded options to configure scripts.
285# Each macro requires bcond name and accepts optional option name, if option
286# isn't specified bcond name is used as option name. Options returning
287# --with and --enable also allow third argument which will be added as value
288# ( --with-option=value or --enable-option=value ) in case or positive
289# condition, but won't be added otherwise ( nothing or just --disable-option ).
290
291# Requirements:
292# BuildRequires: rpmbuild(macros) >= 1.527
293
294# Usage example:
295# %{__enable bcond} - returns --enable-bcond iff build condition is set
296# %{__disable bcond option} - returns --enable-option iff bcond is not set
297# %{__enable_disable bcond option value} - returns --enable-option=value if
298# bcond is set, returns --disable-option otherwise
299
300# expand bconds to --enable-something and --disable-something
301%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
302%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
303%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
304
305# same as above, but condition inverted
306%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
307%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
308%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
309
310# expand bconds to --with-something and --without-something
311%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
312%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
313%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
314
315# same as above, but condition inverted
316%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
317%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
318%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
319
320#-----------------------------------------------------------------
321
b3b1397b
ER
322# overload to insert debuginfo package
323%prep \
324%if 0%{?_enable_debug_packages}\
325%{debug_package}\
326%endif\
327%%prep\
328%{nil}
329
9c404149 330# Location of autoconf macros
7f0f4a79 331%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 332
e2804f99 333# Location of omf files
7f0f4a79 334%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 335
e987a186 336# Location of pkgconfig files
9a4e877a 337%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
338# noarch pkgconfig files
339%_npkgconfigdir /usr/share/pkgconfig
e987a186 340
486b0b5f 341# Location of desktop files
342%_desktopdir /usr/share/applications
86dff2d0 343%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 344
481463e9 345# Location of pixmaps for applnk/desktop files
e1f0a822 346%_pixmapsdir /usr/share/pixmaps
9c404149 347
481463e9 348# Location of themable icons for applnk/desktop files
b36c8e2a 349%_iconsdir /usr/share/icons
350
e987a186
JB
351# Location of fonts directories
352%_fontsdir /usr/share/fonts
353
b3282f3f 354# Location of Gtk and associated libraries documentation
fe6c4bdd 355%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 356
fc4d7771 357# Location of KDE documentation
fe6c4bdd 358%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 359
5869828c 360# unsermake script
361%__unsermake /usr/share/unsermake/unsermake
362
9c404149 363# Current date
8cf161e2 364%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 365
9c404149
AM
366# Example files, programs, scripts...
367%_examplesdir /usr/src/examples
368
c8f7e820 369# Alternative kernel type/version
261729d9 370%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 371
8377d27d 372# The directory holding Linux kernel sources
261729d9 373%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 374
c0fe61f0
ER
375# SysV-style initscripts dir
376%_initddir /etc/rc.d/init.d
377
9c404149 378# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 379%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 380
c924d9d8
ER
381# -n drm to generate kernel%{_alt_kernel}-drm dependency
382%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
383%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
384%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 385
c924d9d8 386# -s post to generate Requires(post) dependency
63d9963a
ER
387%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
388%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
389%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 390
410df6e8
ER
391# Requires name = version-release
392%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 393# Requires: name = version
91d2f1eb 394%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 395# Requires: name = version (version based on querying package %2)
0d3e64c0 396%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 397
c94807f3 398%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 399
400# kernel version-release handling
95125403
ER
401%__kernel_ver %{expand:%%global __kernel_ver %( \\
402 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
403 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
404 echo ${Z:-ERROR}; \\
1a7d3518 405)}%__kernel_ver
95125403 406
c94807f3
ER
407%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
408%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
409%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
410%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 411
6262f001
ER
412# `uname -r` to be used in @release field
413%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
414
e00dd7f6 415# sgml macros
3241033b
ER
416%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
417%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
418%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
419%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
420%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
421%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 422%docbook_sgmlcat_fix() { for l in \
423'' \
424' -- default decl --' \
425'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
426' -- hacks for opensp --' \
427'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
428'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
429'' \
430; do echo $l; done >> %1 \
431}
432
eea64748
ER
433# vim - "
434
4f044018
ER
435# minimum file size needed for compressed documents.
436# just smaller files than this get larger when compressed.
a88ae20f
ER
437# some stats:
438# - 0 byte file compressed was 25 bytes .gz
439# - 39 byte file was compressed as 57
440# - with test/test.spec@man 158 byte file was compressed also 158
441%_min_compress_bytes 159
4f044018 442
9c404149
AM
443#-----------------------------------------------------------------
444# find and gzip all files in %{_mandir} and %{infodir}
445#
446# Requires: xargs, find
447#
448#%no_install_post_compress_docs 1
449%__spec_install_post_compress_docs { \
53d5af13 450%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 451 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 452 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 453 echo "Compress man pages: $i"; \
4f044018
ER
454 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
455 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
456 find $RPM_BUILD_ROOT$i -type l | while read a; do \
457 m=$(readlink $a); \
458 rm -f $a; \
459 echo .so ${m##*/} > $a; \
460 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
461 done; \
4f044018 462 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
463 fi; \
464 done; \
728ad671
JB
465 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
466 echo "Compress info pages: %{_infodir}"; \
467 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
468 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
469 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 470 fi; \
53d5af13 471}; __spec_install_post_compress_docs } }
9c404149
AM
472
473#-----------------------------------------------------------------
474# Strip executable binaries and shared object files
475#
476# Requires: find, awk, strip, cut, xargs
477#
a2ad2754
JB
478# Special macros which affect this process:
479#%no_install_post_strip 1 # disable stripping at all
480#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
481#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
482#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
483#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
484#
9c404149 485%__spec_install_post_strip {%{!?debug: \
53d5af13 486%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 487if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
488 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
489 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
490 if [ "$modulelist" ]; then \
491 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 492 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
493 echo "$modulelist" | xargs -l512 chmod u+w; \
494 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
495 echo "DONE"; \
496 fi; \
eea64748 497 fi; \
0ac49134 498 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
499 if [ -n "$filelist" ]; then \
500 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
501 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
502 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 503 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 504 if [ -n "$elfexelist" ]; then \
4d5370ac 505 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
506 chmod u+w $elfexelist; \
507 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
508 echo "DONE"; \
509 fi; \
510 if [ -n "$elfsharedlist" ]; then \
4d5370ac 511 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
512 chmod u+w $elfsharedlist; \
513 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
514 echo "DONE"; \
515 fi; \
516 if [ -n "$archiveslist" ]; then \
4d5370ac 517 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
518 chmod u+w $archiveslist; \
519 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
520 echo "DONE"; \
521 fi; \
98a06bad 522 fi; \
0ac49134
ER
523 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
524 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
525 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 526 if [ -n "$filelist_all" ]; then \
4d5370ac 527 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 528 chmod u+w $filelist_all; \
f89ccb5f 529 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 530 echo "DONE"; \
9c404149 531 fi; \
f89ccb5f 532 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 533 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 534 chmod u+w $filelist_unneeded; \
f89ccb5f 535 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 536 echo "DONE"; \
8f74418b 537 fi; \
f89ccb5f 538 if [ -n "$filelist_debug" ]; then \
4d5370ac 539 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 540 chmod u+w $filelist_debug; \
f89ccb5f 541 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 542 echo "DONE"; \
9f0d4f36 543 fi; \
53d5af13 544fi; }; __spec_install_post_strip } } }
3241033b 545
fc5d7e20 546#-----------------------------------------------------------------
547# remove all RPATH from executable binaries and shared object files
548#
549# Requires: find, awk, cut, xargs, chrpath, uname
550#
a2ad2754
JB
551# Special macros which affect this process
552#%no_install_post_chrpath 1 # disable chrpath at all
553#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
554#
fc5d7e20 555%__spec_install_post_chrpath {%{!?debug: \
53d5af13 556%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 557if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 558 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 559 if [ -n "$files" ]; then \
d5517264 560 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 561 fi; \
98a06bad 562 if [ -n "$objs" ]; then \
4d5370ac 563 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
564 echo "$objs" | \
565 while read file; do \
566 rpath= ; \
567 chmod u+w "$file"; \
5541bf26 568 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
569 case $dir in \
570 '$ORIGIN' ) \
571 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
572 else rpath="$rpath:$dir" ; fi ; \
573 continue ; \
574 ;; \
575 esac ; \
f9abaddb
AM
576 newdir=$(readlink -m "$dir"); \
577 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
578 case $dir in \
579 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
580 echo "remove-rpath: $dir in $file"; \
581 ;; \
582 * ) \
583 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
584 else rpath="$rpath:$dir" ; fi ; \
585 ;; \
586 esac ; \
587 done ; \
588 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
589 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
590 done; \
591 fi; \
53d5af13 592fi; }; __spec_install_post_chrpath } } }
3241033b 593
611a25d5 594# vim: "
595
d366d7e0
AM
596#-----------------------------------------------------------------
597# Find all shared object files with unresolved symbols. Warn
598# and terminate if any found (termination can be turned off by define).
599#%no_install_post_check_so 1
600%__spec_install_post_check_so { \
601 __spec_install_post_check_so() { \
602 fail=0; \
603 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 604 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 605 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
606 done ; \
607 echo " DONE"; \
14ae3117 608 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
609}; __spec_install_post_check_so }}
610
d72c185f 611#-----------------------------------------------------------------
ccb8ae8d 612# Find and gzip all kernel modules
613#
614# Requires: find
615#
fe6c4bdd 616#%no_install_post_compress_modules 1
ccb8ae8d 617%__spec_install_post_compress_modules { \
53d5af13 618%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 619 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 620 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
621 if [ "$q" ]; then \
622 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
623 echo "$q" | xargs -r %{__gzip} -9nf; \
624 echo "DONE"; \
625 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
626 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
627 fi; \
3241033b 628 fi; \
53d5af13 629}; __spec_install_post_compress_modules } }
9c404149 630
ef64802f
ER
631# Remove common Perl files we don't package
632%__spec_install_post_perl_clean {\
633%{!?no_install_post_perl_clean: \
634%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
635} }
636
83094b62 637#-----------------------------------------------------------------
0e4cb4dd 638# Update GConf2 schemas
83094b62 639#
640# Requires: GConf2
641#
46885239 642%gconf_schema_install() \
307ac6c9
ER
643 umask 022; \
644 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
645 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 646%{nil}
46885239 647
648%gconf_schema_uninstall() \
24336a54 649if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 650 umask 022; \
24336a54
ER
651 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
652 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 653fi; \
f93109a0 654%{nil}
655
656#-----------------------------------------------------------------
657# Update desktop MIME database
c0a4caa0 658# requires: desktop-file-utils
c3bcd10e 659%update_desktop_database() {{ \
f93109a0 660 umask 022; \
fb59e475 661 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
662};} \
663%{nil}
f93109a0 664
c3bcd10e
ER
665%update_desktop_database_post %update_desktop_database
666
667%update_desktop_database_postun() {{ \
f27cf2fd 668if [ "$1" = "0" ]; then \
c00bf95c 669 %update_desktop_database \
f27cf2fd 670fi; \
c00bf95c
MB
671};} \
672%{nil}
f93109a0 673
fb59e475 674#-----------------------------------------------------------------
675# Update shared MIME info database
676# requires: shared-mime-info
677#
c3bcd10e 678%update_mime_database() {{ \
fb59e475 679 umask 022; \
680 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
681};} \
682%{nil}
fb59e475 683
684#-----------------------------------------------------------------
685# Update icon cache
686# requires: gtk+
687#
c3bcd10e 688%update_icon_cache() {{ \
fb59e475 689 umask 022; \
072f4b80 690 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
691};} \
692%{nil}
fb59e475 693
f93109a0 694#-----------------------------------------------------------------
695# Update scrollkeeper database
696# requires: scrollkeeper
697#
698%scrollkeeper_update_post() \
f93109a0 699 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 700%{nil}
f93109a0 701
702%scrollkeeper_update_postun() \
f27cf2fd 703if [ "$1" = "0" ]; then \
f93109a0 704 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 705fi; \
f93109a0 706%{nil}
707
9c404149
AM
708#-----------------------------------------------------------------
709# post %install sequence:
710# - autodeps exceptions
711# - compress all man and info pages,
712# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 713# - compress kernel modules if any
9c404149
AM
714
715###################################################################
716# Requires/Provides automation
3e202b06 717# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 718#
2892b5df
JB
719%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
720%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
721%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
722%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
723%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 724
338726a6
JB
725#%_noautocompressdoc %{nil}
726#
8f74418b
MM
727%_missing_doc_files_terminate_build 1%{nil}
728%_unpackaged_files_terminate_build %{nil}
8781dc74 729# (X)emacs support
d77dcb61 730%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
731%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
732%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 733
02b58f60
JK
734%__php_provides %{nil}
735%__php_requires %{nil}
736%__perl_provides %{nil}
737%__perl_requires %{nil}
fa3497cd 738%__mono_provides %{nil}
739%__mono_requires %{nil}
25043cd4
AF
740
741# Perl specific macro definitions.
c94807f3
ER
742%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
743%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
744%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
745%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
746%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
747%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 748
45c00b39 749# Ruby
c94807f3
ER
750%__ruby /usr/bin/ruby
751%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
752%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
753%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
754%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
755%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
756%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
757%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 758%ruby_rdocdir /usr/share/rdoc
c94807f3 759%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
760%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
761%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 762
7ccf7643 763%php_pear_dir /usr/share/pear
7813c433 764%php_data_dir /usr/share/php
c94807f3
ER
765%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
766%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
767%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 768
0c5d1b9b 769# extract php/zend api versions
c94807f3 770%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 771%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
772%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
773%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
774%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
775%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
776%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
777%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
778
779# helper macro
f952c0f3 780%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
781
782# macros for public use
783# for php extensions (php-pecl)
68b68193 784%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 785%{__php_api_requires zend_module_api} \
f952c0f3
ER
786%{__php_api_requires -v %php_major_version debug php_debug} \
787%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 788
c1b2705c
ER
789# for zend extensions
790%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 791%{__php_api_requires zend_extension_api} \
f952c0f3
ER
792%{__php_api_requires -v %php_major_version debug php_debug} \
793%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 794
934c685f
ER
795# for php pdo modules (php-pecl-PDO_*)
796%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
797
6c3b8203
ER
798# for using PHP post scripts. for PHP >= 5.0
799%php_webserver_restart \
800[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 801[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 802if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
803 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
804 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
805 %service -q php-fcgi restart \
806 fi \
807fi \
8e2cfc36
ER
808if [ -x /etc/rc.d/init.d/php-fpm ]; then \
809 %service -q php-fpm restart \
810fi \
6c3b8203
ER
811%{nil}
812
813# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
814%php4_webserver_restart \
815[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 816[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 817if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
818 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
819 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
820 %service -q php-fcgi restart \
821 fi \
822fi \
6c3b8203
ER
823%{nil}
824
578e9248 825# X.org helper macros
434ab5a2
ER
826%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
827%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
828
c94807f3
ER
829%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
830%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
831%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
832%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
833%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 834# vim: '
578e9248 835
434ab5a2 836%requires_xorg_xserver_extension \
97486460
AM
837%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
838%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
839%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
840%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
841%{nil}
842
843%requires_xorg_xserver_xinput \
97486460
AM
844%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
845%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
846%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
847%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
848%{nil}
849
850%requires_xorg_xserver_font \
97486460
AM
851%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
852%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
853%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
854%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
855%{nil}
856
857%requires_xorg_xserver_videodrv \
97486460
AM
858%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
859%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
860%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
861%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 862%{nil}
578e9248 863
15d7cc4a
ER
864# TCL specific macro definitions.
865# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
866%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
867%tcl_sitearch %{_libdir}/tcl%{tcl_version}
868%tcl_sitelib %{_datadir}/tcl%{tcl_version}
869
25043cd4
AF
870# Python specific macro definitions.
871# python main version
2383a9da 872%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
873
874# directories
2383a9da 875%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 876%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 877%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 878%py_incdir /usr/include/python%{py_ver}
7ccf7643 879%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 880%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 881%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
882
883# pure python modules compilation
3241033b 884%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 885
3241033b 886%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
887
888# Software written in Python language require Python with main version
e63cd81d 889%pyrequires_eq() Requires: %1
25043cd4 890
4bf34b55
AF
891# Python 3.x
892# python main version
e9f00395 893%__python3 python3
4bf34b55
AF
894%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
895
896# directories
897%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
898%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
899%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
900%py3_incdir /usr/include/python%{py3_ver}
901%py3_sitedir %{py3_libdir}/site-packages
902%py3_sitescriptdir %{py3_scriptdir}/site-packages
903%py3_dyndir %{py3_libdir}/lib-dynload
904
905# pure python modules compilation
906%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
907
908%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
909
f12c2314 910# Hardlink binary identical .pyc and .pyo files
f12c2314 911%__spec_install_post_py_hardlink {\
53d5af13 912%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
913local a b c=0 t=0; \
914if [ -d "$RPM_BUILD_ROOT" ]; then \
915 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
916 while read a; do \
917 b="${a%.pyc}.pyo"; \
918 if cmp -s "$a" "$b"; then \
919 ln -f "$a" "$b"; \
920 c=$((c + 1)); \
921 fi; \
922 t=$((t + 1)); \
923 done < __rpm_pyc; \
924 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
925 rm -f __rpm_pyc; \
926fi; \
53d5af13 927}; __spec_install_post_py_hardlink } }
f12c2314 928
9227b3f9 929# remove python sources, so that check-files won't complain
f12c2314 930%py_postclean() \
0f82e280 931for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 932 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
933done \
934%{nil}
935
4bf34b55
AF
936%py3_postclean() \
937for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
938 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
939done \
940%{nil}
941
0fc5cff8 942# depmod macro
943%depmod() { \
f6148427 944umask 022; \
0fc5cff8 945if [ -e /boot/System.map-%1 ]; then \
3241033b 946 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 947else \
3241033b
ER
948 if [ -e /boot/System.map ]; then \
949 /sbin/depmod -a -F /boot/System.map %1; \
950 else \
951 /sbin/depmod -a %1; \
952 fi \
0fc5cff8 953fi; \
954}
955
2afc6e64 956# XMMS specific macros
c94807f3
ER
957%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
958%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
959%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
960%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
961%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
962%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
963%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
964%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
965%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
966%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
967
c28a1d6a 968%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
d1537778 969
848c0d68 970# user/group checking macros
971#
972# Usage:
973# %userremove myuser
974#
975%userremove /usr/lib/rpm/user_group.sh user del
976%groupremove /usr/lib/rpm/user_group.sh group del
977#
978# Usage:
979# if %usertestrm myuser; then
980# /usr/sbin/userdel -r myuser
981# Note:
982# use these macros only if you need to call userdel/groupdel with
983# a non-standard option or take an extra action; otherwise use the
984# %userremove/%groupremove macros
985#
986%usertestrm /usr/lib/rpm/user_group.sh user testrm
987%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
988# user group membership management macros
989#
990# Usage:
efbc7726 991# %addusertogroup [-q] myuser agroup
08d9b1f6 992#
efbc7726
ER
993# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
994#
995# Requirements:
996# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
997%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
998%{nil}
72fcfcb3 999
1000# banner support (useful in {pre,post}{,un} and triggers)
1001#
1002# Usage:
aa41c920 1003# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1004# the banner text, the banner text
aa41c920
ER
1005# the banner text, and following line
1006#EOF
1007# You can use any form of here-document, <<'EOF' <<-EOT will do.
1008# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1009#
72fcfcb3 1010# -a - append to the banner
a8b9562a 1011# -e - send to stderr instead of stdout
628754cb 1012# -n - no show banner (overrides -t)
1013# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1014#
1015# Tests:
1016# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1017# rpm -E 'date | %banner -e banner' > m; sh -x m
1018#
afb54f6c 1019%banner(aent:) ( \
1b334fe4 1020RPM_SCRIPTVERBOSITY=5 \
1021[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1022if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1023 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1024else \
a8b9562a 1025 CMD="cat%{-e: >&2}" \
1b334fe4 1026fi \
276a7b45
ER
1027eval $CMD %{?2:%2}%{?3: %3}) \
1028%{nil}
628754cb 1029
990bd03f 1030# useradd/groupadd macros
4c73bc69 1031# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1032#
1033# Usage:
1034# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1035# [-g initial_group] [-G group[,...]] login
1036#
1037# -u uid. REQUIRED
1038# -g gid/group. REQUIRED
1039# -s defaults to /bin/false
1040# -d defaults to /usr/share/empty
1041# -c No default
1042# -r is accepted but ignored (it's always set)
6bd4c218 1043# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1044# rpm specific flags
1045# -P package name. defaults to %{name}
1046#
90627280 1047%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1048%{!-u:%{error:useradd: Required argument -u missing}} \
1049%{!-g:%{error:useradd: Required argument -g missing}} \
1050%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1051if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1052 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1053 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1054 exit 1 \
1055 fi \
1056else \
1057 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1058 /usr/sbin/useradd \\\
b5a7d552 1059 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1060 -u %{-u*} \\\
1061 -r \\\
1062 -d %{-d*}%{!-d:/usr/share/empty} \\\
1063 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1064 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1065 -g %{-g*} \\\
1066 %{-M} \\\
1067 %{-G:-G %{-G*}} \\\
1aac682a 1068 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1069 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1070fi;
611a25d5 1071# vim: "
90627280 1072
90627280
ER
1073# Usage:
1074# %groupadd [-P package] [-g gid] group
1075#
1076# -g gid. REQUIRED
1077#
1078# Sample:
1079# %groupadd -P %{name}-base -g %{gid} %{name}
1080
1081%groupadd(g:P:rfo) \
9ba02ba9
ER
1082%{!-g:%{error:groupadd: Required argument -g missing}} \
1083%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1084if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1085 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1086 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1087 exit 1 \
1088 fi \
1089else \
1090 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1091 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1092 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1093fi;
7cb77741 1094
7c50f037 1095# webapp macros
4c73bc69 1096# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1097#
1098# The config is installed/removed inside trigger, this means that you can any
1099# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1100# updated. if you don't need the config for various reason for specific
35663282
ER
1101# webserver, just remove the symlink from config directory using webapp
1102# program. the trigger will not recreate the symlink on upgrades. In other
1103# words the config is linked to webserver config directory on first install of
1104# PACKAGE or WEBSERVER.
1105#
7c50f037
ER
1106# Add package's webserver config to webserver webapps dir.
1107# Usage:
aea687a7 1108# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1109#
aea687a7 1110%webapp_register(f) \
35663282 1111%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1112if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1113 /usr/sbin/webapp register %1 %2\
1114fi\
694a8f2e 1115# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1116if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1117 %{expand:%service -q %%1 reload}\
35663282
ER
1118fi\
1119%{nil}
1120
1121# Remove package's config from webserver webapps dir.
35663282 1122# Usage:
531c0efc
ER
1123# %webapp_register [-f] WEBSERVER WEBAPP
1124%webapp_unregister(f) \
35663282
ER
1125%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1126# remove link if either of the packages are gone \
5d3a09a3 1127if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1128 /usr/sbin/webapp unregister %1 %2\
16897aea 1129 %{expand:%service -q %%1 reload}\
35663282
ER
1130fi \
1131%{nil}
1132
462b26fa 1133# service macro.
4c73bc69 1134# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1135#
1136# calls usual service restart on package %post, but skips the restart if
1137# administrator has disabled automatic service restarts in either global
1138# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1139#
462b26fa 1140# Usage:
7377b5ca 1141# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1142#
a0bbe604 1143# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1144# -n NOOP mode, do not actually restart service
462b26fa 1145#
7377b5ca
ER
1146# Requirements:
1147# BuildRequires: rpmbuild(macros) >= 1.268
1148# Requires: rc-scripts
1149# -n option:
1150# BuildRequires: rpmbuild(macros) >= 1.450
1151%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1152
1153
f9aa75bf
ER
1154# Java macros. based on jpackage macros.java
1155#
1156# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1157%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1158
1159# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1160%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1161
1162# Root directory for all Java VM/SDK/JRE's private things.
1163%_jvmprivdir %{_libdir}/jvm-private
1164
1165# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1166%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1167
1168# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1169%_jvmdatadir %{_datadir}/jvm
1170
1171# Root directory for all configurations parts of Java VM/SDK/JRE's
1172%_jvmsysconfdir %{_sysconfdir}/jvm
1173
1174# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1175%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1176
1177# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1178%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1179
1180# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1181%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1182
1183# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1184%_jnidir %{_libdir}/java
f9aa75bf 1185
c94807f3 1186%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1187
a9254650 1188%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1189%jar %{java_home}/bin/jar
c94807f3 1190%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1191%javac %{java_home}/bin/javac
1192%javadoc %{java_home}/bin/javadoc
6aedae62 1193
fe6c4bdd 1194%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1195
1196%jpackage_script() \
3ca65b87
ER
1197install -d $RPM_BUILD_ROOT%{_bindir}\
1198cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1199#!/bin/sh\
1200#\
1201# %{name} script\
1202# JPackage Project <http://www.jpackage.org/>\
1203\
1204# Source functions library\
1205. %{_javadir}-utils/java-functions\
1206\
1207# Source system prefs\
3ca65b87 1208if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1209 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1210fi\
1211\
1212# Source user prefs\
3ca65b87
ER
1213if [ -f $HOME/.%{name}rc ]; then\
1214 . $HOME/.%{name}rc\
6aedae62
ER
1215fi\
1216\
1217# Configuration\
1218MAIN_CLASS=%1\
1219BASE_FLAGS=%2\
1220BASE_OPTIONS=%3\
3ca65b87 1221BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1222\
1223# Set parameters\
1224set_jvm\
3ca65b87
ER
1225set_classpath $BASE_JARS\
1226set_flags $BASE_FLAGS\
1227set_options $BASE_OPTIONS\
6aedae62
ER
1228\
1229# Let's start\
3ca65b87 1230run "$@"\
6aedae62
ER
1231EOF
1232
06f11871
ER
1233# jpackage 1.7
1234# Directory for maven depmaps
1235#
1236%_mavendepmapdir /etc/maven
1237%_mavendepmapfragdir /etc/maven/fragments
1238
1239#
1240# add_to_depmap adds an entry to the depmap. The arguments are:
1241#
1242# %1 the original groupid
1243# %2 the original artifact id
1244# %3 the version
1245# %4 the new groupid
1246# %5 the new artifactid
1247#
1248
1249%add_to_maven_depmap() \
1250install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1251cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1252<dependency>\
1253 <maven>\
1254 <groupId>%1</groupId>\
1255 <artifactId>%2</artifactId>\
1256 <version>%3</version>\
1257 </maven>\
1258 <jpp>\
1259 <groupId>%4</groupId>\
1260 <artifactId>%5</artifactId>\
1261 <version>%3</version>\
1262 </jpp>\
1263</dependency>\
1264\
1265EOF\
1266%{nil}
1267
1268#==============================================================================
1269#
1270# update_maven_depmap updates the main maven depmap
1271#
1272%update_maven_depmap() \
1273echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1274if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1275cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1276fi\
1277echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1278
02c5f99a 1279# JAVA macros specific for PLD
1280
1281# Directory for tomcat context configuration files
1282%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1283
59d3ebe9 1284# PEAR install macros
4c73bc69 1285# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1286#
1287# Usage:
f7ecf326 1288# %%pear_package_setup ...
dfce8b19 1289#
59d3ebe9 1290# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1291# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1292# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1293# -D - pass -D to %setup (so the build dir is not removed)
1294# -c - register channel from local channel.xml file
dfce8b19
ER
1295#
1296# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1297# destination hierarchy. you should copy the tree to buildroot after
1298# patching/reorganizing with %%pear_package_install.
1299#
1300# additionally BUILDROOT is stripped from files and files are converted to UNIX
1301# line endings.
1302#
1303# the pear install process output is recorded to install.log, you should put it
8763f51e 1304# to %%doc for later debug or just for information.
dfce8b19
ER
1305#
1306# additionally additional-packages.txt is produced if it was detected that the
1307# package has optional dependencies. the file format is suitable of displaying
1308# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1309# automatically added for this file.
59d3ebe9
ER
1310
1311
1312# records install.log and transforms PEAR names to PLD Linux rpm package names.
1313%__pear_install_log \
1314tee install.log \
1315# make post message of optional packages \
f64d1bb2 1316grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1317if [ -s optional-packages.txt ]; then \
1318 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1319else \
1320 rm -f optional-packages.txt \
1321fi \
1322%{nil}
1323
1324# command invoking pear cli
1325%__pear /usr/bin/pear
1326
67a089ff 1327%pear_install(a:n:zD) \
59d3ebe9 1328%__pear \\\
f7ecf326 1329 -c %{builddir}/pearrc \\\
dfce8b19 1330 -d doc_dir=/docs \\\
f7ecf326
ER
1331 -d temp_dir=/tmp \\\
1332 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1333 -d bin_dir=%{_bindir} \\\
1334 -d data_dir=%{php_pear_dir}/data \\\
1335 -d test_dir=%{php_pear_dir}/tests \\\
1336 install \\\
59d3ebe9 1337 --packagingroot=%{builddir} \\\
dfce8b19
ER
1338 --offline \\\
1339 --nodeps \\\
1340 %{-f:--force} \\\
67a089ff 1341 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1342 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1343%{nil}
1344
1345# The main macro.
1346# using this macro will append optional-packages.txt to the nocompressdoc list
1347# as it's displayed to user after package install. and adding additional gzip
1348# dep is just waste ;)
f7ecf326 1349%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1350%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1351%define builddir %{_builddir}/%{srcdir} \
1352%setup -q -c -T %{-D:-D} -n %{srcdir} \
1353%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1354%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1355%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1356%pear_install \
59d3ebe9
ER
1357%{-z:cd ..} \
1358cat %{-z:$_N/}.install.log | %__pear_install_log \
1359\
dfce8b19 1360# undos sources \
2a80e4cf 1361find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1362%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1363%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1364%{nil}
1365
7bef60e8 1366# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1367# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1368%pear_package_install() \
1369cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1370find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1371# help the developer out a little: \
1372if [ -f _noautoreq ]; then \
1373 echo "AutoReqdep detected:" \
1374 echo "_noautoreq $(cat _noautoreq)" \
1375fi \
1376%{nil}
1377
0d5dd00c
ER
1378
1379# Register OpenLDAP schema.
4c73bc69 1380# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1381#
1382# Usage:
1383# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1384#
1385# -d specify dependant schemas, separated by comma
1386#
1387%openldap_schema_register(d:) \
1388for schema in %*; do \
1389 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1390 %{__sed} -i -e " \
1391 /^include.*local.schema/{ \
1392 iinclude\\t $schema\
1393 } \
1394 " /etc/openldap/slapd.conf \
1395 fi \
1396done \
1397# enable dependant schemas \
1398if [ "%{-d*}" ]; then \
1399 %{__sed} -i -e ' \
1400 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1401 s/^#// \
1402 }' /etc/openldap/slapd.conf \
1403fi \
1404%{nil}
1405
1406# Unregister OpenLDAP schema.
4c73bc69 1407# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1408#
1409# Usage:
1410# %%openldap_schema_unregister %{schemadir}/horde.schema
1411#
1412%openldap_schema_unregister() \
1413for schema in %*; do \
1414 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1415 %{__sed} -i -e " \
1416 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1417 # for symmetry it would be nice if we disable enabled schemas in post, \
1418 # but we really can not do that, it would break something else. \
1419 " /etc/openldap/slapd.conf \
1420 fi \
1421done \
1422%{nil}
1423
b0bc2936 1424%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1425
dcc6baf7 1426
1427# Build modules for kernels 2.6
1428# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1429#
1430# Usage:
aa559e46 1431# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1432#
1433# remember that proper Makefile is still required
1434# Options:
990bd03f 1435# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1436# without .ko extension, may be placed in subdirectory
aa559e46 1437# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1438# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1439# -c -- do not execute make clean
dcc6baf7 1440# <additional arguments> -- all additional arguments will be passed to
1441# make modules
1442#
1443# Additional patching supported via here document. Try:
1444# %build_kernel_modules -m module <<'EOF'
1445# your patch script here
1446# EOF
1447# Don't use it unless patching depends on config options.
1448
1449# Developer note: don't touch it unless you know how to handle '\'.
1450# - \ in script expands to nothing
1451# - \\\ in script expands to \
566398b4 1452# - \\\ inside definition expands to nothing
dcc6baf7 1453# - \\\\\\\ inside definition expands to \
1454# - in last line \ has to touch arguments so arguments passing
1455# in new lines (using \) will be supported
1456
5a81d83e 1457%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1458%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1459 \
1460%define Opts \\\\\\\
1461%if "%{_target_base_arch}" != "%{_arch}" \\\
1462 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1463 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1464 %else \\\
1465 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1466 %endif \\\
1467%else \\\
88608ef7 1468 CC="%{kgcc}" \\\
dcc6baf7 1469%endif \
88608ef7 1470%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1471 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1472 \
e364bc26 1473%{?-C:cd %{-C*}} \
dcc6baf7 1474compile() { \
ba9de9b2
ER
1475 local L="<" PATCH_SH; \
1476 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1477 set -e -x \
730239f9 1478 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1479 \
730239f9 1480for cfg in ${cfgs:-dist}; do \
dcc6baf7 1481 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1482 \
c546f6fb 1483 rm -rf o \
68cfe9d9 1484 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1485 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1486 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1487 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1488 \
1489 set +x \
1490 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1491 set -x \
1492 \
c768535c 1493 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1494 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1495 %{-p*} %{-P*} \\\
1496 %{MakeOpts} \
1497 %else \
1498 install -d o/include/config \
1499 touch o/include/config/MARKER \
588f1b0b 1500 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1501 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1502 %endif \
1503 \
5a81d83e 1504 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1505 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1506 ${1+"$@"} \\\
5a81d83e 1507 M=$PWD %{MakeOpts}} \
f635907b 1508 \
dcc6baf7 1509 %{__make} -C %{_kernelsrcdir} modules \\\
1510 ${1+"$@"} \\\
1511 M=$PWD %{MakeOpts} \
1512 \
1513 for MODULE in {%{-m*},}; do \
1514 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1515 done \
1516done \
aa559e46 1517%{?-C:cd -} \
dcc6baf7 1518} \
1519compile %{*}\
1520%{nil}
1521
1522
1523# Install kernel modules built by %build_kernel_modules
1524# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1525#
1526# Usage:
1527# %install_kernel_modules -m <modules> -d <directory>
1528#
1529# Options:
990bd03f 1530# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1531# without .ko extension, may be placed in subdirectory
1532# -d <directory> (required) -- in what subdirectory modules should be
1533# installed (eg. misc, kernel/drivers/net)
1534# -s <suffix> -- suffix to use when installing modules, useful when module
1535# with same name exists in kernel already
1536# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1537# for defining aliases, only useful with -s
dcc6baf7 1538
1539%install_kernel_modules(m:d:s:n:) \
1540%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1541%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1542%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1543 \
1544%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1545%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1546 \
b279feda 1547__install_kernel_modules() { \
730239f9 1548local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1549 \
1550for MODULE in {%{-m*},}; do \
1551 [ -n "${MODULE}" ] || continue \
730239f9
ER
1552 for cfg in ${cfgs:-dist}; do \
1553 [ "$cfg" = smp ] && suf=smp || suf= \
1554 MNAME=${MODULE##*/} \
1555 install -D ${MODULE}-$cfg.ko \\\
1556 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1557 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1558 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1559 >> %{ModprobeD}$suf/%{-n*}.conf} \
1560 done \
dcc6baf7 1561done \
b279feda 1562} \
1563__install_kernel_modules \
dcc6baf7 1564%{nil}
1565
fa65356c 1566# patchset macros
4c73bc69 1567# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1568#
1569# Usage:
1570# %patchset_source -f <seq(1) format> <start> [<end>]
1571# %patchset_patch <start> [<end>]
1572#
1573# If <end> is omited, it is assumed to be <start>.
1574#
1575# For example in preamble:
1576# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1577# and in %prep:
1578# %patchset_patch 33 44
1579
1580# generate SourceX urls from range START STOP
1581# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1582# The sources start from 10000
e91610db 1583%patchset_source(f:b:) %(
44f733ef 1584 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1585 start=$(expr $base + %1);
1586 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1587 # we need to call seq twice as it doesn't allow two formats
1588 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1589 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1590 paste %{tmpdir}/__ps{1,2};
1591 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1592) \
1593%{nil}
fa65356c
ER
1594
1595# apply sources from %patchset_source
1596# -p specify -pX for %patch line
1597# -b base offset: defaults to 10000
1598%patchset_patch(f:p:b:) %(
44f733ef 1599 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1600 start=$(expr $base + %1);
1601 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1602 echo ": patchset_patch %1%{?2: to %2}";
1603 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1604) \
1605%{nil}
fa65356c 1606
5730b44b 1607# browser plugins v2
4c73bc69 1608# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1609#
1610# Usage:
1611# %browser_plugins_add_browser <name> -p <plugindir>
1612#
1613# <name> (required) -- name of the browser. usually %{name}.
1614# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1615# -b -- default blacklists
1616# -a <arch> override arch
5730b44b
ER
1617#
1618# Example:
1619# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1620
1621%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1622%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1623%update_browser_plugins /usr/sbin/update-browser-plugins || :
1624
02ebf70f 1625%browser_plugins_add_browser(p:b:a:) \
9efd458e 1626 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1627 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1628 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1629 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1630 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1631 %{-b:cat >> $blacklist_file %{-b*}} \
1632%{nil}
1633
ad17b654
ER
1634# Helper for LUA.
1635# split string separated by space into quoted list
1636#
4c73bc69 1637# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1638#
1639# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1640%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1641
1642# adjust /etc/shells by adding and removing shells from there
4c73bc69 1643# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1644#
1645# Usage:
d9b789d9
ER
1646# %post -p <lua>
1647# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1648#
d9b789d9
ER
1649# %preun -p <lua>
1650# if arg[2] == 0 then
1651# %lua_remove_etc_shells /bin/bash /bin/rbash
1652# end
7377b5ca
ER
1653#
1654# Requirements:
d9b789d9
ER
1655# BuildRequires: rpmbuild(macros) >= 1.462
1656#
ad17b654 1657
d9b789d9 1658%lua_add_etc_shells() \
ad17b654
ER
1659t = {}\
1660f = io.open("/etc/shells", "r")\
1661if f then\
1662 for l in f:lines() do t[l]=l; end\
1663 f:close()\
1664end\
1665for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1666 if not t[s] then\
b8c0bc18 1667 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1668 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1669 end\
1670end\
1671%{nil}
1672
d9b789d9
ER
1673%lua_remove_etc_shells() \
1674t = {}\
1675f = io.open("/etc/shells", "r")\
1676if f then\
1677 for l in f:lines() do t[l]=l; end\
1678 f:close()\
1679end\
1680for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1681 print("Removing "..l.." from /etc/shells")\
1682 t[l] = nil\
1683end\
1684s=""\
1685for _, l in pairs(t) do\
1686 s=s..l.."\\n"\
1687end\
1688io.open("/etc/shells", "w"):write(s)\
1689%{nil}
1690
1691# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1692#
1693# Author: Elan Ruusamäe <glen@pld-linux.org>
1694#
1695# Usage:
1696# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1697# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1698#
1699# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1700#
1701# Requirements:
1702# BuildRequires: rpmbuild(macros) >= 1.429
1703#
1704%add_etc_shells(p) %{-p:<lua>}\
1705%{expand:%%lua_add_etc_shells %*}\
1706%{nil}
1707
ad17b654 1708%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1709%{-p:if arg[2] == 0 then}\
d9b789d9 1710%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1711%{-p:end} \
ad17b654
ER
1712%{nil}
1713
75bd6249
ER
1714# Check syntax for Python files
1715#
1716# Author: Elan Ruusamäe <glen@pld-linux.org>
1717# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1718#
1719# Usage:
1720# %py_lint src
1721#
1722# Requirements:
1723# BuildRequires: python
1724# BuildRequires: rpmbuild(macros) >= 1.469
1725
1726%py_lint() \
1727__py_lint() { \
1728find "$@" -type f -name '*.py' | python -c ' \
1729import sys \
1730import compiler \
1731\
1732err = 0\
1733for f in sys.stdin: \
1734 fd = open(f.strip()) \
1735 c = fd.read() \
1736 fd.close() \
1737 try: \
1738 compiler.parse(c) \
1739 except SyntaxError, e: \
1740 print "py_lint: %s: %s" % (f.strip(), e) \
1741 err = err + 1\
1742\
1743if err: \
1744 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1745 sys.exit(1) \
1746else: \
1747 print >> sys.stderr, "py_lint: Found no syntax errors." \
1748' \
1749}; __py_lint %* \
1750%{nil}
1751
f602e4a0 1752# Undos files
1753#
1754# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1755#
1756# Usage:
1757# %undos list_of_files
1758#
1759# Requirements:
1760# BuildRequires: sed >= 4.0
1761# BuildRequires: rpmbuild(macros) >= 1.533
1762
1763%undos \
1764%{__sed} -i -e 's,\\r$,,'
1765
f51bfb2f 1766# vim:ts=4 sw=4 noet ft=spec
This page took 0.57082 seconds and 4 git commands to generate.